/*     
 * $RCSfile: saidmgr.h,v $
 *
 * $LOG$
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994,1993,1991,1990  Arizona Board of Regents
 *
 *
 *
 */

#ifndef saidmgr_h
#define saidmgr_h


#define SAIDMGR_GETLSAID		(SAIDMGR_CTL*MAXOPS+0)
#define SAIDMGR_GETSA			(SAIDMGR_CTL*MAXOPS+1)
#define SAIDMGR_GETREMOTEALGORITHM	(SAIDMGR_CTL*MAXOPS+2)
#define SAIDMGR_RESOLVE_NAME		(SAIDMGR_CTL*MAXOPS+3)
#define SAIDMGR_RESOLVE_MODE            (SAIDMGR_CTL*MAXOPS+4)
#define SAIDMGR_RESCAN_PRESET_KEY_FILE  (SAIDMGR_CTL*MAXOPS+5)
#define SAIDMGR_GET_SPIS_FOR_HOST       (SAIDMGR_CTL*MAXOPS+6)
#define SAIDMGR_KEYSIZE			512

typedef	int	XSaid;
typedef int	XAlgorithm;
typedef int	XAlgoPara;
typedef int	XIpsecMode;

#define  	SA_NO_PADDING	0
#define		SA_8BYTE_DES_PADDING 	1

typedef struct kma_mapping {
     XAlgorithm	local_algorithm;
     XAlgoPara	local_parameter;
     XIpsecMode	local_mode;
     int	local_iv_length;
     int	local_hash_size;
     int	local_padding_type;
     XSaid	remote_said;
     IPhost     remote_host;
     XAlgorithm	remote_algorithm;
     XAlgoPara	remote_parameter;
     XIpsecMode	remote_mode;
     int	remote_iv_length;
     int	remote_hash_size;
     int	remote_padding_type;
} KMA_MAPPING;

typedef struct kmb_mapping {
     IPhost     local_host;
     XAlgorithm	local_algorithm;
     XAlgoPara	local_parameter;
     XIpsecMode	local_mode;
     int	local_timeout;
     char	local_key[SAIDMGR_KEYSIZE];
     XSaid	remote_said;
     IPhost     remote_host;
     XAlgorithm	remote_algorithm;
     XAlgoPara	remote_parameter;
     XIpsecMode	remote_mode;
     int	remote_timeout;
     char	remote_key[SAIDMGR_KEYSIZE];
} KMB_MAPPING;

#  ifdef __STDC__

void    saidmgr_init( XObj );

#  endif


#endif
