/*
 *   IPSEC Security Assocation
 *
 *      Used by the IPSEC protocol and the key exchange protocol
 *
 *      Depends on saidmgr.h
 */

#ifndef SECASSN_T

#define SECASSN_T

typedef xk_int32  spi_t;

typedef struct {
  spi_t spi;
  spi_t remote_spi;
  int   type;  /* the ipsec type */
  int	iv_size;
  int	hash_size;
  int	padding_type;
  char  *iv_tmp;
  XIpsecMode	mode;
  int	esp_alg;
  int	ah_alg;
  XAlgorithm	alg;
  IPhost src_addr;  /* we might set up something for a gateway */
  IPhost dst_addr;
  XObj   downs;  /* down session for this algorithm */
} sa_t;

#endif
