/*
 * $RCSfile: lcp_constants.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994  Arizona Board of Regents
 *
 * $Log: lcp_constants.h,v $
 * Revision 1.2  1994/10/27 17:27:04  andrey
 * removed non-ansi definitions
 *
 * Revision 1.1  1994/10/24  20:46:02  andrey
 * Initial revision
 *
 *
 * $Revision: 1.2 $
 * $Date: 1994/10/27 17:27:04 $
 */

/* from RFC 1548 */

/* Link Control Protocol(LCP) Specific Values */

#define LCP_CODE_REJ	0x7    /* Code Reject                           */
#define LCP_PROT_REJ	0x8    /* Protocol Reject                       */
#define LCP_ECHO_REQ	0x9    /* Echo Request                          */
#define LCP_ECHO_REP	0xa    /* Echo Reply                            */
#define LCP_DISC_REQ	0xb    /* Discard Request                       */

/* LCP Configuration Options Values */
#define LCP_MRU		0x1    /* Maximum Receive Unit, aka MTU         */
#define LCP_ACCM	0x2    /* Async-Control-Character-Map           */
#define LCP_AUTH	0x3    /* Authentication Protocol               */
#define LCP_QUAL	0x4    /* Quality Protocol                      */
#define LCP_MAGIC	0x5    /* Magic Number                          */
#define LCP_PFC		0x7    /* Protocol-Field-Compression            */
#define LCP_ACFC	0x8    /* Address-and-Control-Field-Compression */

#define LCP_MAXOPT	LCP_ACFC

#define LCP_UNKNOWN	(LCP_MAXOPT+1)	/* implementation flag */
					/* for questionable code */

#define	LCP_MIN_MRU	128	/* not per RFC 1548, but seems like a	*/
				/* good idea				*/
