/*
 * $Source: /home/mjk/dist/protocols/join_server/RCS/kedat2edat.c,v $
 * $Author: dcs $
 *
 * Copyright 1990 by the Massachusetts Institute of Technology.
 * All Rights Reserved.
 *
 * Export of this software from the United States of America is assumed
 *   to require a specific license from the United States Government.
 *   It is the responsibility of any person or organization contemplating
 *   export to obtain such a license before exporting.
 * 
 * WITHIN THAT CONSTRAINT, permission to use, copy, modify, and
 * distribute this software and its documentation for any purpose and
 * without fee is hereby granted, provided that the above copyright
 * notice appear in all copies and that both that copyright notice and
 * this permission notice appear in supporting documentation, and that
 * the name of M.I.T. not be used in advertising or publicity pertaining
 * to distribution of the software without specific, written prior
 * permission.  M.I.T. makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is" without express
 * or implied warranty.
 * 
 *
 * Glue between Kerberos version and ISODE 6.0 version of structures.
 */

#if !defined(lint) && !defined(SABER)
static char rcsid_kedat2edat_c[] =
"$Id: kedat2edat.c,v 1.1 1994/03/08 17:54:13 dcs Exp $";
#endif	/* lint || saber */

#include <krb5/krb5.h>

/*#include <time.h> */
#include <isode/psap.h>
#include <krb5/asn1.h>
#include "asn1glue.h"

/* #include <krb5/ext-proto.h> */

/* ISODE defines max(a,b) */

struct type_KRB5_EncryptedData *
krb5_enc_data2KRB5_EncryptedData(val, error)
const register krb5_enc_data *val;
register int *error;
{
    register struct type_KRB5_EncryptedData *retval;
 
    retval = (struct type_KRB5_EncryptedData *)xmalloc(sizeof(*retval));
    if (!retval) {
	*error = ENOMEM;
	return(0);
    }
    xbzero(retval, sizeof(*retval));

    retval->etype = val->etype;
/* #ifdef REAL_KERBEROS */
    retval->cipher = krb5_data2qbuf(&(val->ciphertext));
    if (!retval->cipher) {
	xfree(retval);
	*error = ENOMEM;
	return(0);
    }
/* #endif */
    if (val->kvno) {
	retval->optionals = opt_KRB5_EncryptedData_kvno;
	retval->kvno = val->kvno;
    }
    return(retval);
}
