#define MAX_BYTES   1000000        /* max bytes to send in TIME_UNIT  */
#define MAX_MSGS    30             /* max msgs to send in TIME_UNIT   */
#define TIME_UNIT   1000           /* in milliseconds                 */
#define SUB_INT     8              /* # of sub-intervals in TIME_UNIT */

#define MsgQueued( ss )   ((ss)->MsgQueue.next != &((ss)->MsgQueue))
#define MsgCanGo( ss, m ) ((ss)->MsgsToSend > 0 && (ss)->BytesToSend >= msgLen(m))

typedef struct {
  int  MsgsSent;
  int  BytesSent;
} Interval;

typedef struct {
  Sessn  RC_sessn, lls;
} PState;
 
typedef struct node {
  struct node *next, *prev;
  Msg   *m;
  Sessn tcp_s;
  u_short len;
  int num;
} queueNode;


typedef struct {
  int      MsgsToSend, BytesToSend;
  Interval Info[SUB_INT];
  int      current;
  Event    rateProcess, queueMgr;
  int      Blocked;
  Semaphore Sem, queueSem;
  queueNode MsgQueue;
  char      queueMgrRunning;
  int       queuenum;
} SState;

int tracercp;

void rc_init (Protl);
static void             getproc_sessn( Sessn );
static void             getproc_protl( Protl );
static xkern_return_t   rcClose( Sessn );
static int              rcControlProtl( Protl, int, char *, int ) ;
static int              rcControlSessn( Sessn, int, char *, int ) ;
static Sessn             rcCreateSessn( Protl, Protl, Protl, Sessn );
static xkern_return_t   rcDemux( Protl, Sessn, Msg * );
static Sessn             rcOpen( Protl, Protl, Protl, Part * );
static xkern_return_t   rcOpenEnable( Protl, Protl, Protl, Part * );
static xkern_return_t   rcPop( Sessn, Sessn, Msg *, void * );
static xmsg_handle_t    rcPush( Sessn, Msg * );
static void             rcRateController ( Event, void * );
static void             rcQueueManager ( Event, void * );
static void             rcEnqueueMsg ( SState *, Msg * );
static Msg             *rcDequeueMsg ( SState *, Sessn *, u_short * );
static void             rcInternalPush (Sessn s, Msg *m, Sessn tcp_s, 
					u_short len);



