#include "/home/moe/xkernel/include/xkernel.h"
#include "/home/moe/xkernel/include/gc.h"
#include "/home/moe/xkernel/include/prot/arp.h"
#include "ppp_values.h"

#include <sys/stropts.h>
#include <fcntl.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <sys/termios.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>


#define	ACTIVE_MAP_SIZE     23
#define	PASSIVE_MAP_SIZE    23
#define TLEN                3
#define HLEN                5
#define DEVICEA             "/dev/ttya"
#define DEVICEB             "/dev/ttyb"
#define INUSE               1
#define TTYB                2
#define NOREF               0
#define CLEAR_REF(_bp)      (_bp)->ref = NOREF
#define MAX_SERIAL_BLOCKS   64
#define PPP_MAX_INSTANCES   32
#define XOR                 0x20
#define CEO                 0x7d
#define PPPINITFCS      0xffff  /* Initial FCS value */

static void getproc_protl();
static XObj serialCreateSessn();
static void getproc_sessn();
static xkern_return_t serialPop();
static xkern_return_t serialCloseSessn();
static xkern_return_t serialDemux();
static xkern_return_t serialOpenEnable();
static xmsg_handle_t serialPush();
int serialControlProtl();
static xkern_return_t serialCloseProtl();
static xkern_return_t serialOpenDisable();
static int readserial2demux();
void ppp_serial_init();
int PPP_handle_msg();

extern int    pppfcs();
extern void   installSignalHandler();
extern int   getpid();
extern void   perror();
extern int    ioctl();
extern int   read_rom();
extern int    select();
extern int    write();
extern int    read();
extern void   Init_blocks();
extern void   clear_buf();

extern  int        PPP_handle_msg();
bool        send_data();
void        init_send();
static void
block_handler();
void init_serial_blocks();

#define SERIAL_MAX_INTERFACES  8


typedef struct activeid {
  int device_name;
} ActiveId;

typedef struct passiveid {
  int device_name;
} PassiveId;


typedef struct i_face_type {
  int  MYPPPAddr_int;
  int  THEIRPPPAddr_int;
  int  mtu;
  int  device;
} i_face;

typedef struct pppstate {
  Map    activemap;
  Map    passivemap;
  int    n_interfaces;
  int    llpProt;
  i_face interface[SERIAL_MAX_INTERFACES]; 
} SERIALPSTATE;

typedef struct sstate {
  u_short   Protocol;
  int       State;
  u_char    *bptr;
  int       iplen;
  int       msglen;
  u_char    *realbufPtr;
  u_char    *orealbufPtr;
} SERIALSSTATE;

typedef struct {
    char id;
    char ref;
    int cur_len;
    u_char *data;
    u_char *data_buf;
    Msg *msg; 
    Semaphore sem;
    XObj self;
} block;

block *old_bp;

typedef struct {
    int total_blocks;
    int next_block;
    block blocks[MAX_SERIAL_BLOCKS];
} block_pool;

typedef unsigned short u16;
struct termios tio;
int  traceserialp,leng;
int  tty_fd,reset_again=0;
int CHUNK = 1,hand=0;
extern int already_opened;
extern block_pool pool;
extern XObj ppp_obj;
extern int instance;
static int Done = 1;
extern int  DEVICE_MTU;
static int  activeThreads;
static int  activeHighWater;
